//#define I2C_DEBUG

#include <stdio.h>
#include "includes.h"
#include <system.h>
#include <altera_avalon_pio_regs.h>
#include <altera_avalon_uart_regs.h>
#include <fcntl.h>

#include "packet_buffer.h"
#include "bluetooth_helpers.h"

/* Definition of Task Stacks */
#define   TASK_STACKSIZE       2048
OS_STK    task1_stk[TASK_STACKSIZE];
OS_STK    task2_stk[TASK_STACKSIZE];
OS_STK    task3_stk[TASK_STACKSIZE];

/* Definition of Task Priorities */

#define TASK1_PRIORITY      1
#define TASK2_PRIORITY      2
#define TASK3_PRIORITY      3


int receiveCount = 0x01;
int currentCommand = 0x00;
int currentLights = 0x00;

char charInter = 0;
char charRecv = 0;
char curCommand = 0;
char sendCount = 0;


/* The main function creates two task and starts multi-tasking */
int main(void)
{
	printf("Starting?\n");

    INT8U err;
    if(initBluetooth()) {
    	  OSTaskCreateExt(sendTask,
    	                  NULL,
    	                  (void *)&task1_stk[TASK_STACKSIZE-1],
    	                  TASK1_PRIORITY,
    	                  TASK1_PRIORITY,
    	                  task1_stk,
    	                  TASK_STACKSIZE,
    	                  NULL,
    	                  0);

    	  OSTaskCreateExt(receiveTask,
    	                  NULL,
    	                  (void *)&task2_stk[TASK_STACKSIZE-1],
    	                  TASK2_PRIORITY,
    	                  TASK2_PRIORITY,
    	                  task2_stk,
    	                  TASK_STACKSIZE,
    	                  NULL,
    	                  0);

    	  // Just for debug - see echoTask for how to create your own useful task
    	  OSTaskCreateExt(echoTask,
    	                  NULL,
    	                  (void *)&task3_stk[TASK_STACKSIZE-1],
    	                  TASK3_PRIORITY,
    	                  TASK3_PRIORITY,
    	                  task3_stk,
    	                  TASK_STACKSIZE,
    	                  NULL,
    	                  0);
    } else {
    	IOWR(PIO_LEDS_BASE, 0, 0xEE);
    }

  if(alt_ic_isr_register(
				  UART_BLUETOOTH_IRQ_INTERRUPT_CONTROLLER_ID,
				  UART_BLUETOOTH_IRQ,
				  &bluetoothIRQ,
				  NULL,
				  NULL
  )) {
      printf("Register failed\n");
  }

  OSStart();
  return 0;
}

/******************************************************************************
*                                                                             *
* License Agreement                                                           *
*                                                                             *
* Copyright (c) 2004 Altera Corporation, San Jose, California, USA.           *
* All rights reserved.                                                        *
*                                                                             *
* Permission is hereby granted, free of charge, to any person obtaining a     *
* copy of this software and associated documentation files (the "Software"),  *
* to deal in the Software without restriction, including without limitation   *
* the rights to use, copy, modify, merge, publish, distribute, sublicense,    *
* and/or sell copies of the Software, and to permit persons to whom the       *
* Software is furnished to do so, subject to the following conditions:        *
*                                                                             *
* The above copyright notice and this permission notice shall be included in  *
* all copies or substantial portions of the Software.                         *
*                                                                             *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR  *
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,    *
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE *
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER      *
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING     *
* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER         *
* DEALINGS IN THE SOFTWARE.                                                   *
*                                                                             *
* This agreement shall be governed in all respects by the laws of the State   *
* of California and by the laws of the United States of America.              *
* Altera does not recommend, suggest or require that this reference design    *
* file be used in conjunction or combination with any other product.          *
******************************************************************************/
